client/New()
	..()
	mob.Party.Add(mob)
	mob.verbs += typesof(/mob/No_Party/verb)

mob/var
	moving = 0
	movement_delay = 2
	lock = 0
	prex = 1
	prey = 1
	prez = 1
	predir = SOUTH

mob/Move()
	if(moving != 1 && src.lock == 0)
		if(src.Party.len > 1 && src.Leader != src)return
		//Moving
		moving = 1
		//Party Check
		if(src.Leader == src && src.Party.len > 1)
			src.prex = src.x
			src.prey = src.y
			src.prez = src.z
			src.predir = src.dir
		//Moving
		..()
		//Party Move Check
		if(src.Leader == src && src.Party.len > 1)
			for(var/mob/m in src.Party)if(m != src)
				if(src.Party.len > m.Party_Pos)
					m.prex = m.x
					m.prey = m.y
					m.prez = m.z
					m.predir = m.dir
				var/mob/p = m.Party[m.Party_Pos - 1]
				m.loc = locate(p.prex, p.prey, p.prez)
				m.dir = p.predir
		//Movement_Delay
		spawn(movement_delay)moving = 0

mob/var
	list/Party = list()
	Leader
	InParty = 0
	Party_Ask = 0
	Party_Pos = 1

mob/proc/Clear_Party_Stats()
	src.Give_No_Party_Verbs()
	src.density = 1
	src.InParty = 0
	src.Party_Ask = 0
	src.Party_Pos = 1
	src.layer = MOB_LAYER
	src.Leader = null
	src.Party = list(src)

mob/No_Party/verb
	Create_Party()
		set category = "Party"
		for(var/mob/m in view(src))if(m.client)m<<"<small><b>[src] forms a party!"
		if(src.Party.len == 1)
			src.Leader = src
			src.InParty = 1
		src.verbs += typesof(/mob/Party_Leader/verb)
		src.Remove_No_Party_Verbs()
	Join()
		set category = "Party"
		for(var/mob/m in get_step(src, src.dir))
			if(m.Leader != m)src<<"[m] isn't the leader of a party."
			if(m.Leader == m && m.Party_Ask != 1)// && m.Party.len < 4) // You can limit how many are allowed in the party right here.
				m.Party_Ask = 1
				src<<"<small><b>Asking [m] to join his party."
				var/i = alert(m,"[src] wants to join the party","Accept?","Yes","No")
				var/confirm = 0
				for(var/mob/p in view(1,m))if(p == src)confirm = 1
				if(i == "No" && confirm == 1 && src.Party.len == 1 && src.Leader != src)src<<"<small><b>[m] has rejected your request!"
				if(confirm == 0)
					m<<"<b><small>[src] is too far away from you to join the party."
					m.Party_Ask = 0
					return
				if(src.Party.len != 1 || src.Leader == src)
					m<<"<b><small>[src] has all ready joined a party."
					m.Party_Ask = 0
					return
				if(i == "Yes")
					m.Party.Add(src)
					m.Refresh_Party()
				else if(i == "No")
					m.Party_Ask = 0
					return
				m.Party_Ask = 0
				src.InParty = 1
				src.verbs += typesof(/mob/In_Party/verb)
				src.Remove_No_Party_Verbs()
				src.density = 0
				src.layer--
				m.Party_Message("<small><b>[src] joins the party!")
				return
			else if(m.Party.len == 4)
				src<<"<b><small>[m]'s Party is full!"
				return
			else if(m.Party_Ask == 1)
				src<<"<b><small>Someone is all ready asking if they can join [m]'s party.  Try again later."


mob/proc/Party_Message(msg as text)for(var/mob/m in src.Party)m<<msg

mob/In_Party/verb
	Leave()
		set category = "Party"
		for(var/mob/m in src.Party)if(m.Leader == m)
			m.Party.Remove(src)
			m.Refresh_Party()
			m.Party_Message("<small><b>[src] has left the party!")
			src<<"<small><b>You have left the Party!"
			break
		src.Clear_Party_Stats()

mob/Party_Leader/verb
	Disband_Party()
		set category = "Party"
		src.Party_Message("<small><b>[src] disbands the party!")
		for(var/mob/m in src.Party)if(m != src)
			m.Clear_Party_Stats()
		src.Clear_Party_Stats()
	Kick_From_Party()
		set category = "Party"
		var/list/temp = list()
		for(var/m in src.Party)if("[m]" != "[src.name]")temp.Add(m)
		temp.Add("Cancel")
		var/i = input("Who would you like to kick from the party?","Kick") in temp
		if(i == "Cancel")return
		for(var/mob/m in src.Party)
			if("[m.name]" == "[i]")m<<"<small><b>You have been kicked out of the party!"
			else m<<"<small><b>[i] has been kicked out of the party!"
		src.Party_Remove(i)

mob/proc/Remove_No_Party_Verbs()
	src.verbs -= typesof(/mob/No_Party/verb)

mob/proc/Give_No_Party_Verbs()
	src.verbs += typesof(/mob/No_Party/verb)
	src.verbs -= typesof(/mob/Party_Leader/verb)
	src.verbs -= typesof(/mob/In_Party/verb)

mob/proc/Party_Remove(var/t as text)
	for(var/mob/m in src.Party)if("[m.name]" == "[t]")
		src.Party.Remove(m)
		m.Clear_Party_Stats()
		break
	src.Refresh_Party()

mob/proc/Refresh_Party()
	for(var/mob/m in src.Party)if(m != src)m.Party = src.Party
	var/count = 0
	for(var/mob/m in src.Party)
		count++
		m.Party_Pos = count

mob/verb/Parties()
	set category = "Party"
	src<<"<b><small><u>Parties:"
	for(var/mob/m in world)if(m.client && m.InParty == 1 && m.Leader == m)
		src<<" - <b><small><u>[m]'s Party"
		for(var/mob/p in m.Party)
			if(p.Leader == p)src<<"    - <b><small>[p]([p.key]) - Party Leader"
			else src<<"    - <b><small>[p]([p.key])"
